struct oper table[] = {
"adc",  GEN,    0xA9,	2,
"add",  GEN,    0xAB,	2,
"and",  GEN,    0xA4,	2,
"asl",  GRP2,   0x38,	4,
"asla", INH,    0x48,   3,
"aslx", INH,    0x58,   3,
"asr",  GRP2,   0x37,	4,
"asra", INH,    0x47,   3,
"asrx", INH,    0x57,   3,
"bcc",  REL,    0x24,	3,
"bclr", SETCLR, 0x11,   5,
"bcs",  REL,    0x25,	3,
"beq",  REL,    0x27,	3,
"bhcc", REL,    0x28,	3,
"bhcs", REL,    0x29,	3,
"bhi",  REL,    0x22,	3,
"bhs",  REL,    0x24,	3,
"bih",  REL,    0x2F,	3,
"bil",  REL,    0x2E,	3,
"bit",  GEN,    0xA5,	2,
"blo",  REL,    0x25,	3,
"bls",  REL,    0x23,	3,
"bmc",  REL,    0x2C,	3,
"bmi",  REL,    0x2B,	3,
"bms",  REL,    0x2D,	3,
"bne",  REL,    0x26,	3,
"bpl",  REL,    0x2A,	3,
"bra",  REL,    0x20,	3,
"brclr",BTB,    0x01,   5,
"brn",  REL,    0x21,	3,
"brset",BTB,    0x00,   5,
"bset", SETCLR, 0x10,   5,
"bsr",  REL,    0xAD,   6,
"clc",  INH,    0x98,	2,
"cli",  INH,    0x9A,	2,
"clr",  GRP2,   0x3F,	4,
"clra", INH,    0x4F,   3,
"clrx", INH,    0x5F,   3,
"cmp",  GEN,    0xA1,	2,
"cmpx", GEN,    0xA3,	2,
"com",  GRP2,   0x33,	4,
"coma", INH,    0x43,   3,
"comx", INH,    0x53,   3,
"cpx",  GEN,    0xA3,	2,
"dec",  GRP2,   0x3A,	4,
"deca", INH,    0x4A,   3,
"decx", INH,    0x5A,   3,
"eor",  GEN,    0xA8,	2,
"inc",  GRP2,   0x3C,	4,
"inca", INH,    0x4C,   3,
"incx", INH,    0x5C,   3,
"jmp",  NOIMM,  0xAC,   1,
"jsr",  NOIMM,  0xAD,   4,
"lda",  GEN,    0xA6,	2,
"ldx",  GEN,    0xAE,	2,
"lsl",  GRP2,   0x38,	4,
"lsla", INH,    0x48,   3,
"lslx", INH,    0x58,   3,
"lsr",  GRP2,   0x34,	4,
"lsra", INH,    0x44,   3,
"lsrx", INH,    0x54,   3,
"mul",  INH,    0x42,  11,             /* HC05C4 ONLY */
"neg",  GRP2,   0x30,	4,
"nega", INH,    0x40,   3,
"negx", INH,    0x50,   3,
"nop",  INH,    0x9D,	2,
"ora",  GEN,    0xAA,	2,
"rol",  GRP2,   0x39,	4,
"rola", INH,    0x49,   3,
"rolx", INH,    0x59,   3,
"ror",  GRP2,   0x36,	4,
"rora", INH,    0x46,   3,
"rorx", INH,    0x56,   3,
"rsp",  INH,    0x9C,	2,
"rti",  INH,    0x80,   9,
"rts",  INH,    0x81,   6,
"sbc",  GEN,    0xA2,	2,
"sec",  INH,    0x99,	2,
"sei",  INH,    0x9B,	2,
"sta",  NOIMM,  0xA7,   3,
"stop", INH,    0x8E,   2,      /* CMOS only */
"stx",  NOIMM,  0xAF,   3,
"sub",  GEN,    0xA0,	2,
"swi",  INH,    0x83,   10,
"tax",  INH,    0x97,	2,
"tst",  GRP2,   0x3D,	3,
"tsta", INH,    0x4D,   3,
"tstx", INH,    0x5D,   3,
"txa",  INH,    0x9F,	2,
"wait", INH,    0x8F,   2       /* CMOS only */
};
