/* configur.h 8-10-91  configurable parameters at compile time */
/** Tierra Simulator V3.0: Copyright (c) 1991 Thomas S. Ray **/

#include "license.h"

/*
#ifndef lint
static char     sccsid[] = "%W%     %G%";
#endif
*/

#ifndef CONFIGUR_H
#define CONFIGUR_H

#define INSTBITNUM 5
#define INSTNUM 32         /* INSTNUM = 2 ^ INSTBITNUM */
#define PLOIDY 1

#ifndef INST
#define INST 1 
#endif

#define STDIO      0
#define GREENLEAF  1

#ifndef FRONTEND
#define FRONTEND STDIO
#endif

#if INST == 1
#define STACK_SIZE 10
#define NUM_REGS 4
#endif

/* #define ERROR */    /* use to include error checking code */
/* #define SOCKETS */    /* define for socket communications */

/* the following definitions should be provided by the compilers,
   except for IBM3090 which must be manually defined */

/* __TURBOC__  = Turbo C for DOS */
/* OS2_MC      = Microsoft C for OS/2 */
/* IBM3090     = IBM 3090 the compiler will not define this, do it manually */
/* unix        = for unix systems */
/* __GNUC__    = gcc unix compiler */
/* ANSI        = for ANSI environment */

#endif
