/* arginst.h  8-10-91  Artificial Life simulator setup routines */

#include "license.h"

/*
#ifndef lint
static char sccsid[] = "%W%	%G%";
#endif
*/

#ifndef ARGINST_H
#define ARGINST_H

I32s  GeneBnker = 1; /* turn genebanker on and off */
I32s  RateMut = 2000; /* mutation rate control by raw rate, ("cosmic ray") */
I32s  RateMovMut = 2000; /* mut rate control by raw rate, (copy mutation) */
I32s  RateFlaw = 2000; /* flaw control by raw rate */
I32s  NumCells = 1; /* # of creatures and gaps used to inoculate new soup */

/* the aid[INSTNUM] array is created by editing the id[INSTNUM] array
   in soup_in.h */

#if INST == 1

struct ArgInstDef  aid[INSTNUM] =
    {{ 0x00, "nop_0" },
     { 0x01, "nop_1" },
     { 0x02, "or1" },
     { 0x03, "shl" },
     { 0x04, "zero" },
     { 0x05, "if_cz" },
     { 0x06, "sub_ab" },
     { 0x07, "sub_ac" },
     { 0x08, "inc_a" },
     { 0x09, "inc_b" },
     { 0x0a, "dec_c" },
     { 0x0b, "inc_c" },
     { 0x0c, "push_ax" },
     { 0x0d, "push_bx" },
     { 0x0e, "push_cx" },
     { 0x0f, "push_dx" },
     { 0x10, "pop_ax" },
     { 0x11, "pop_bx" },
     { 0x12, "pop_cx" },
     { 0x13, "pop_dx" },
     { 0x14, "jmp" },
     { 0x15, "jmpb" },
     { 0x16, "call" },
     { 0x17, "ret" },
     { 0x18, "mov_cd" },
     { 0x19, "mov_ab" },
     { 0x1a, "mov_iab" },
     { 0x1b, "adr" },
     { 0x1c, "adrb" },
     { 0x1d, "adrf" },
     { 0x1e, "mal" },
     { 0x1f, "divide" }};

#endif /* INST == 1 */

#endif
