/* debug.h  28-10-91  debugging functions for the tierra simulator */
/** Tierra Simulator V3.0: Copyright (c) 1991 Thomas S. Ray **/
/** Tierra Simulator V3.0: Copyright (c) 1990, 1991 Marc W. Cygnus **/

#include "license.h"

/*
debug_h_sccsid: %W%	%G%
*/

#ifndef _DEBUG_H
#define _DEBUG_H

#ifndef u_long
#include <sys/types.h>
#ifdef __TURBOC__
#define u_long unsigned long
#endif
#endif

#ifdef _DBGMainModule
u_long		debug_state = 0L;
#else
extern u_long	debug_state; 
#endif

#define	DEBUG(dbgst)	if (debug_state & (dbgst)) {
#define	ENDDB()		}

#define	DBGIOTrace	0x0001
#define	DBGIOTrace2	0x0002
#define	DBGReqTrace	0x0004
#define	DBGFlowCon	0x0008

#define DBGX		0x0010

#define DBGD		0x0020

#endif	/* add nothing past this line */
