/* prototyp.h 28-10-91 */
/* function prototypes for tierra simulator, included at end of tierra.h */
/** Tierra Simulator V3.0: Copyright (c) 1991 Thomas S. Ray **/

#include "license.h"

/*
tierra_h_sccsid: @(#)prototyp.h	1.5	9/21/91
*/

#ifndef PROTOTYP_H
#define PROTOTYP_H 

extern void DivideBookeep P_((I32s  ci, I32s  ni));
extern void OutDisk P_((I8s  bd, Pcells  nc));
extern void ReapBookeep P_((I32s  ci));
extern void MutBookeep P_((Ind  i));
extern void plan P_((void));
extern void extract P_((I32s  ci));
extern void GetGenFileList P_((void));
extern void InitGList P_((Pgl  g, I32s  si, I32s  gi, I32s  size));
extern void find_gl P_((struct genotype  *g, struct gl_index  *gli));
extern void CheckGenotype P_((I32s  ci, struct gl_index  *gli));
extern void IsNewSize P_((I32s  ci, struct gl_index  *gli));
extern I8s  IsInGenQueue P_((I32s  ci, struct gl_index  *gli));
extern I8s  IsInGenBank P_((I32s  ci, struct gl_index  *gli));
extern void NewGenotype P_((I32s  ci, struct gl_index  *gli));
extern I32u WhoIs P_((I32s  *ci, Ind  a));
extern void AddToGl P_((struct gl_index  *gli));
extern I8s  IsSameGen P_((I32s  size, HpInst  g1, HpInst  g2));
extern void AddTopGenQueue P_((struct gl_index  *gli));
extern void MovToTopGenQueue P_((struct gl_index  *gli));
extern void DelBotGenQueue P_((void));
extern void IncrLbl P_((I8s  *lbln, I8s  *lblo));
extern void MaxLbl P_((I8s  *lbl, I8s  *s));
extern I32s Lbl2Int P_((I8s  *s));
extern void Int2Lbl P_((I32s  i, I8s  *s));
extern void DelGenFile P_((Pgl  tgl));
extern FILE *open_ar P_((I8s  *file, I16s  size, I8s  format, I16s  mode));
extern head_t read_head P_((FILE  *fp));
extern void write_head P_((FILE  *fp, head_t  *head));
extern indx_t *read_indx P_((FILE  *fp, head_t  *head));
extern void write_indx P_((FILE  *fp, head_t  *head, indx_t  *indx));
extern I32s find_gen P_((indx_t  indx[], I8s  *gen, I32s  n));
extern Pgl get_gen P_((FILE  *fp, head_t  *head, indx_t  *indxn, I32s  n));
extern I32s add_gen P_((FILE  *fp, head_t  *head, indx_t  **indx, Pgl  gen));
extern I16s GetAscGen P_((Pgl  g, I8s  ifile[]));
extern void WritAscFile P_((Pgl  g, I8s  *file));
extern void WritGenFile P_((Pgl  g, I8s  file[]));
extern I16s GetGenFormat P_((Pgl  g,I8s  file[]));
extern Ascii2Ebcdic P_((I8s  *s));
extern Ebcdic2Ascii P_((I8s  *s));
extern void WritEcoF P_((I32u  bits, FILE  *ouf));
extern void SetBit P_((I32u  *seed, I32u  bit, I32u  value));
extern void nop P_((I32s  ci));
extern void or1 P_((I32s  ci));
extern void shl P_((I32s  ci));
extern void if_cz P_((I32s  ci));
extern void math P_((I32s  ci));
extern void push P_((I32s  ci));
extern void pop P_((I32s  ci));
extern void tcall P_((I32s  ci));
extern void call P_((I32s  ci));
extern void mov P_((I32s  ci));
extern void movdd P_((I32s  ci));
extern void movdi P_((I32s  ci));
extern void movid P_((I32s  ci));
extern void movii P_((I32s  ci));
extern void adr P_((I32s  ci));
extern void mal P_((I32s  ci));
extern void chmode P_((I32s  ci));
extern void malchm P_((I32s  ci));
extern void divide P_((I32s  ci));
extern void CheckCells P_((void));
extern I32s flaw P_((I32s  ci));
extern Ind template
    P_((Ind  f, Ind  b, I32s  tz, I8s  dir, I8s  mode, I32s  ci));
extern Ind btemplate
    P_((Ind  f, Ind  b, I32s  tz, I8s  dir, I8s  mode, I32s  ci));
extern I8s  IsPriv P_((Pcells  ce, Ind  a));
extern I8s IsBitPriv P_((Pcells  ce, Ind  a, I8s  mode, I8s  track));
extern I8s  IsInsideCell P_((Pcells  ce, Ind  a));
extern I8s  IsFree P_((Ind  a));
extern void  WhichCell P_((Ind  a, I32s  *ci, I8s  *md));
extern Ind  MemAlloc P_((I32s  *size));
extern void MemDealloc P_((Ind  p, I32s  size));
extern void SetFlag P_((Pcells  ce));
extern void thfree P_((I8s Hp  ptr));
extern I8s Hp threalloc P_((I8s Hp  ptr, I32u  siz));
extern I8s Hp thcalloc P_((I32u  num, I32u  siz));
extern I32u tfread P_((I8s Hp  ptr, I32s  size, I32s  n, FILE  *stream));
extern I32u tfwrite P_((I8s Hp  ptr, I32s  size, I32s  n, FILE  *stream));
extern I32u ffs P_((I32s  x));
extern void IncrSliceQueue P_((void));
extern void EntBotSlicer P_((I32s  ci));
extern void UpReaper P_((I32s  ci));
extern void DownReaper P_((I32s  ci));
extern void UpRprIf P_((I32s  ci));
extern void DownReperIf P_((I32s  ci));
extern void EntBotReaper P_((I32s  ci));
extern void RmvFrmReaper P_((I32s  ci));
extern void RmvFrmSlicer P_((I32s  ci));
extern void SlicerPhoton P_((void));
extern I32s PhotonFit P_((Ind  a, I8s  *PhotonInst, I32s  PhotonSize));
extern I32s PhotonSlide
    P_((Ind  a, I8s  *PhotonInst, I32s  PhotonSize, I32s  PhotonWidth));
extern void PhotonTranslate P_((I8s  *PhotonInst, I8s  *PhotonWord));
extern void SlicerQueue P_((void));
extern void RanSlicerQueue P_((void));
extern void CoreWarSocket P_((I8s  bd, Ind  p, I32s  size));
extern void CoreWarBalloon P_((void));
extern void setup_tcp_socket P_((void));
extern void shutd P_((I32s  sig, I32s  code, I32s  *scp, I8s  *addr));
extern int main P_((int  argc, char  *argv[]));
extern void life P_((void));
extern void TimeSlice P_((I32s  ci, I32s  size_slice));
extern I16s FetchDecode P_((I32s  ci));
extern void IncrementIp P_((I32s  ci));
extern void SystemWork P_((I32s  ci));
extern void mutate P_((void));
extern void mut_site P_((HpInst  s, I8s  t));
extern void ReapCheck P_((void));
extern void reaper P_((I8s  ex));
extern I32s SubEvent
    P_((struct event  *event1, struct event  *event2, struct event  *result));
extern I32s tlrand P_((void));
extern I16s tirand P_((void));
extern I16u tuirand P_((void));
extern I8s tcrand P_((void));
extern I8u tucrand P_((void));
extern void tsrand P_((I32s  seed));
extern double tdrand P_((void));
extern I8s GetAVar P_((I8s  data[85]));
extern void GetSoup P_((void));
extern void StupGenLists P_((void));
extern void GetNewSoup P_((void));
extern void ReadACreature P_((I8s  *crit, Pcells  ce, I32s  ci, HpInst  si));
extern void GetOldSoup P_((FILE  *inf));
extern void WriteSoup P_((I8s  close_disk));
extern I16s glcmp P_((const void  *gl1, const void  *gl2));
extern I16s slcmp P_((const void  *sl1, const void  *sl2));
extern void InitCell P_((I32s  ci));
extern void GenExExe P_((I32s  ci, Ind  adrt));
extern void GenExMov P_((I32s  ci, I32s  to, I32s  from));
extern void GenExTemp P_((Ind  adrt, I32s  ci, I32s  tsize));
extern void FEMessage P_((I8s  n));
extern void FEError P_((I8s  n));
extern void FEStartup P_((void));
extern void FEPlan P_((I32s  MaxPop, I32s  MaxMem,
            struct genotype  *MaxGenPop, struct genotype  *MaxGenMem));

#if INST == 1

extern void pnop P_((I32s  ci));
extern void por1 P_((I32s  ci));
extern void pshl P_((I32s  ci));
extern void pzero P_((I32s  ci));
extern void pif_cz P_((I32s  ci));
extern void psub_ab P_((I32s  ci));
extern void psub_ac P_((I32s  ci));
extern void pinc_a P_((I32s  ci));
extern void pinc_b P_((I32s  ci));
extern void pdec_c P_((I32s  ci));
extern void pinc_c P_((I32s  ci));
extern void ppush_ax P_((I32s  ci));
extern void ppush_bx P_((I32s  ci));
extern void ppush_cx P_((I32s  ci));
extern void ppush_dx P_((I32s  ci));
extern void ppop_ax P_((I32s  ci));
extern void ppop_bx P_((I32s  ci));
extern void ppop_cx P_((I32s  ci));
extern void ppop_dx P_((I32s  ci));
extern void ptjmp P_((I32s  ci));
extern void ptjmpb P_((I32s  ci));
extern void ptcall P_((I32s  ci));
extern void pret P_((I32s  ci));
extern void pmov_dc P_((I32s  ci));
extern void pmov_ba P_((I32s  ci));
extern void pmov_iab P_((I32s  ci));
extern void padr P_((I32s  ci));
extern void padrb P_((I32s  ci));
extern void padrf P_((I32s  ci));
extern void pmal P_((I32s  ci));
extern void pdivide P_((I32s  ci));

#endif /* INST == 1 */

#endif
